//
//	boresight:	test retrieval of boresight angles
//
#include <iostream>

#include "CalServer.h"
#include "Boresight.h"
#include "Celestial.h"

int main()
{
	calServer.setInstrument(Xmm::EMOS1);
	calServer.state()->ccd()->set(EMOScam::CCD_1);
	calServer.state()->node()->set(EMOScam::PRIMARY_NODE);

	Boresight *bs = calServer.getAtom(bs);
	AttitudeMatrix A(bs->matrix(0.));

	CartesianVector v(1., 0., 0.),
					vres = A*v;
	cout<<vres.x()<<" "<<vres.y()<<" "<<vres.z()<<endl;

	bs->angles(EulerAngles());
	Boresight *bs2 = calServer.getAtom(bs2);
	cout<<"Angles after setting:\n"<<bs2->angles(0.)
		<<"\nand as matrix:\n"<<bs2->matrix(0.)<<endl;

	return 0;
}
