//
//	test the cal rawx2mm calls
//
#include <fstream>
#include <iostream>
#include <iomanip>
#include "CalServer.h"
#include "Xmm.h"
#include "GeometryDataServer.h"
#include "common.h"

int main()
{
	calServer.setInstrument(Xmm::EPN);
	calServer.state()->ccd()->set(4);
	calServer.state()->randomize()->set(false);
	calServer.state()->temperature()->set(293.);
	calServer.state()->temperatureCamera()->set(293.);

	float xmm[] = { 0. },
		  ymm[] = { 0. },
		  zmm[] = { 0. };
	CalReal32Vector x(xmm, 1), y(ymm, 1), z(zmm, 1);
	GeometryDataServer *cdf = calServer.getAtom(cdf);
	XmmCartesianPointList pl = cdf->camCoord2List(x, y, z);
	XmmPixelList pix = pl.toCamCoord1().toChipCoord();
	cout<<pix.x()[0]<<" "<<pix.y()[0]<<endl;

	return 0;
}
