//
//	Test the coordinate conversion chain
//		CHIPCOORD->TOREAL->CAMCOORD1->CAMCOORD2
//
#include <fstream>
#include <iostream>
#include <cmath>
#include "CalServer.h"
#include "Xmm.h"
#include "GeometryDataServer.h"
#include "common.h"

int main()
{
	for (unsigned i = 0; i < xmmPayLoad.instruments().size(); ++i) {

		XmmInstrument *ins = xmmPayLoad.instruments()[i];
		if (ins->id() == Xmm::ERM)
			continue;

		cerr<<"Instrument: "<<Xmm::toString(ins->id())<<endl;
		calServer.setInstrument(ins->id());
		calServer.state()->randomize()->set(false);
		if (calServer.state()->node()->isActive())
			calServer.state()->node()->set(Xmm::PRIMARY_NODE);
		if (calServer.state()->ocb()->isActive())
			calServer.state()->ocb()->set(1);

		for (unsigned ccd = 1; ccd<=ins->nCcds(); ++ccd) {
			calServer.state()->ccd()->set(ccd);

			int16 x = 1, y = 1;
			real32 dx = .1f, dy = .1,
				   xmm, ymm, zmm;
			CalInt16Vector xv(&x, 1), yv(&y, 1);
			CalReal32Vector dxv(&dx, 1), dyv(&dy, 1);

			GeometryDataServer *cdf = calServer.getAtom(cdf);
			XmmRealPixelList pl = cdf->chipCoordList(xv, yv).toReal();

			unsigned n=0;
			while (n<21) {
				XmmCartesianPointList cpl =
						pl.toCamCoord1(&xmm, &ymm, &zmm).toCamCoord2();

				cout<<pl.xr(0)<<"/"<<pl.yr(0)<<" = "
					<<xmm<<"/"<<ymm<<"/"<<zmm<<endl;
				pl.add(dxv, dyv);
				++n;
			}
		}
	}
	return 0;
}
