//
//	test RGA-related stuff; embryonic at the moment; add more test in due
//	time
//
#include <iostream>
#include <cmath>
#include "CalCommon.h"
#include "CalServer.h"
#include "GratingDataServer.h"
#include "Xmm.h"

static bool isClose(double a, double b)
{
    return fabs(a)/fabs(b)-1. < 1.e-5;
}

int main()
{
	const double E = 1100,
				 ALPHA = 2.7*DEG_TO_RAD;
	const int ORDER = -1;

	GratingDataServer *gds = calServer.getAtom(gds);

	double betaM = gds->beta(ALPHA, ORDER, E),
		   order = gds->order(ALPHA, betaM, E),
		   energy = gds->energy(ALPHA, betaM, ORDER);
	cout<<"order="<<order<<endl;
	cout<<"energy="<<energy<<endl;
	assert(isClose(order, ORDER));
	assert(isClose(energy, E));

	return 0;
}

