//
//	test the cal rawx2mm calls
//
#include <fstream>
#include <iostream>
#include <iomanip>
#include "CalServer.h"
#include "Xmm.h"
#include "GeometryDataServer.h"
#include "common.h"

int main()
{
	calServer.setInstrument(Xmm::RGS1);
	calServer.state()->randomize()->set(false);
	calServer.state()->ocb()->set(3);
	CalInt16Vector rawXVec(0, 344),
				   rawYVec(0, 344),
				   chipX(0, 344), chipY(0, 344);
	CalInt8Vector node(0, 344);
	for (unsigned rawX=1; rawX<=172; ++rawX) {
		rawXVec[rawX-1] = rawX;
		rawYVec[rawX-1] = 1;
		node[rawX-1] = 0;
	}
	for (unsigned rawX=172; rawX>=1; --rawX) {
		rawXVec[172+172-rawX] = rawX;
		rawYVec[172+172-rawX] = 1;
		node[172+172-rawX] = 1;
	}

	for (unsigned n=0; n<chipX.size(); ++n)
		cout<<rawXVec[n]<<endl;

	GeometryDataServer *cd = calServer.getAtom(cd);
	XmmPixelList pl = cd->pixCoord1List(rawXVec, rawYVec).toChipCoord(&node);
	XmmCartesianPointList cpl = pl.toCamCoord1();
	calServer.state()->ocb()->set(1);	//	set OCB to 1
	cpl.toChipCoord(chipX, chipY);

	for (unsigned n=0; n<chipX.size(); ++n)
		cout<<rawXVec[n]<<' '<<chipX[n]<<endl;

	return 0;
}
