//-----------------------------------------------------------------------------
//
//						XMM Science Analysis System (SAS)
//					   (c) 1997-2010 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	CalChild.h	--- base class for objects which can be instantiated
//					from other classes
//
//	CHANGE HISTORY:
//		UL, 1998-11-18: 1.0.0: - initial version
//
//	AUTHOR:
//		U. Lammers, Fri Jul 24 09:46:32 MET DST 1998
//
//	REFERENCES:
//		[1]: Software Specification Document for the XMM Science Analysis
//			 Subsystem, M. Dahlem et. al., 
//
//	$Header: /data/xmm12/cvsadmin/soc_repos/sas/packages/cal/src/CalChild.h,v 1.3 2000/03/09 11:47:34 ulammers Exp $
//

#ifndef CAL_CHILD
#define CAL_CHILD

#include "Tracer.h"

template <class T>
class CalChild {
public:
	CalChild(const T *parent) : _parent(parent) { PROC ENDPROC }
	T *parent() { PROC RETURN const_cast<T *>(_parent); }
	const T *parent() const { PROC RETURN _parent; }
	bool isOrphan() const { PROC RETURN !_parent; }

protected:
	void parent(const T *p) { PROC _parent = p; ENDPROC }

private:
	const T * _parent;
};

#endif
